       subroutine cramer( a, x, y, deta )
	  
c***********************************************************************
c      Cramer's rule 
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Sun Jan 18 15:30:00 WEST 2009
c***********************************************************************
       
       integer i,j 
       
       real*8 a(3,3),mx(3,3),my(3,3),mz(3,3)
       
       real*8 x(3),y(3)
       
       real*8 deta,detx,dety,detz
       
c***********************************************************************
       
       call det3x3(a,deta)
       
       if ( deta.ne.0.0 ) then
       
       do i = 1,3
       
          do j = 1,3
          
          mx(i,j) = a(i,j)
          my(i,j) = a(i,j)
          mz(i,j) = a(i,j)
          
          end do 
          
       end do 
       
       do i = 1,3 
       
          mx(i,1) = y(i)
          my(i,2) = y(i)
          mz(i,3) = y(i)
       
       end do 
       
       call det3x3(mx,detx)
       call det3x3(my,dety)
       call det3x3(mz,detz)
       
       x(1) = detx/deta
       x(2) = dety/deta
       x(3) = detz/deta
   
       end if 
       
       return 
        
       end
       
c***********************************************************************
