       subroutine invmat( a , ia, ie )
	  
c***********************************************************************
c      Matrix inverse (2x2 case)
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Thu Jul 07 17:00:00 WEST 2011
c***********************************************************************
       
       integer ie 
       
       real*8 a(2,2),ia(2,2)
       real*8 d
       
       ie = 1 
       
       d = a(1,1)*a(2,2) - a(1,2)*a(2,1)
       
       if (d.ne.0.0) then
       ia(1,1) =  a(2,2)/d 
       ia(1,2) = -a(1,2)/d 
       ia(2,1) = -a(2,1)/d
       ia(2,2) =  a(1,1)/d
       else
       ie = 0
       end if 
       
c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return 
       
       end
