       subroutine reflct( normal, taui, taur , theta )
	  
c***********************************************************************
c      Specular reflection in vector form
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Sat Jun 18 18:00:00 WEST 2011
c****&******************************************************************
       
       real*8 normal(3),taui(3),taur(3)
       
       real*8 c,theta
       
c***********************************************************************
       
       call dot( normal, taui, c )
       
       taur(1) = taui(1) - 2.0*c*normal(1)
       taur(2) = taui(2) - 2.0*c*normal(2)
       taur(3) = taui(3) - 2.0*c*normal(3)
       
       call dot( normal, taur, c )
       
       theta = acos( c )
       
       return 
       
       end
       
c***********************************************************************
