       subroutine blii1d(x,y,xi,yi,yxi)
	  
c***********************************************************************
c      Barycentric Linear Interpolation 1D
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Gambelas, Wed Jun 15 14:00:00 WEST 2011
c***********************************************************************

       real*8 x(2),y(2)
       real*8 xi,x1,x2
       real*8 yi,y1,y2
       real*8 yxi

       x1 = x(1)
       x2 = x(2)
       
       y1 = y(1)
       y2 = y(2)

       yxi = (y2-y1)/(x2-x1)
       
       yi = y1 + yxi*(xi-x1)
       
c***********************************************************************
c     Back to main:
c***********************************************************************
       
       return 
       
       end

