       subroutine det3x3( a, d )
	  
c***********************************************************************
c      Matrix determinant (3x3 case)
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, Sun Jan 18 16:00:00 WEST 2009
c***********************************************************************
       
       real*8 a(3,3)
       real*8 a11,a12,a13
       real*8 a21,a22,a23
       real*8 a31,a32,a33
       real*8 d
       
c***********************************************************************

       a11 = a(1,1)
       a12 = a(1,2)
       a13 = a(1,3)
       
       a21 = a(2,1)
       a22 = a(2,2)
       a23 = a(2,3)
       
       a31 = a(3,1)
       a32 = a(3,2)
       a33 = a(3,3)
           
       d = a11*( a22*a33 - a23*a32 ) + a12*( a23*a31 - a21*a33 ) + 
     &     a13*( a21*a32 - a22*a31 )
       
       return 
        
       end
       
c***********************************************************************
