      subroutine sorti(n,k,ks)
      
c***********************************************************************
c      SORT a vector of integers
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Gambelas, Wed Oct 24 19:01:39 WEST 2012
c****&******************************************************************
      
      integer*4 i,j,ktemp,n
      integer*4 k(n),ks(n)
      
c***********************************************************************
c     Populate ks with the values of k: 
      
       do i = 1,n
        
	  ks(i) = k(i)
	 
       end do

c***********************************************************************
c     Sort:
 
       do i = 1,n-1
	 
	  do j = i+1,n
	    
	     if ( ks(j) .lt. ks(i) ) then
		 
		 ktemp = ks(i)
		 ks(i) = ks(j)
		 ks(j) = ktemp
		 
	     end if
	 
	  end do
      
       end do

c***********************************************************************
       
       return
        
       end
